//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 変換シーンノードマネージャ実装
 * @author Junpee
 */

#include "System/stdafx.h"
#include "Translator/SceneNode/TranslationSceneNodeManager.h"

namespace LampForMaya{

//------------------------------------------------------------------------------
// コンストラクタ
TranslationSceneNodeManager::TranslationSceneNodeManager() :
	database_(256, 0.75f), array_(256){
}
//------------------------------------------------------------------------------
// デストラクタ
TranslationSceneNodeManager::~TranslationSceneNodeManager(){
	Assert(database_.getCount() == 0);
	Assert(array_.getCount() == 0);
	if(getCount() != 0){ clear(); }
}
//------------------------------------------------------------------------------
// シーンノードの収集
bool TranslationSceneNodeManager::collectSceneNodes(){
	MStatus result;
	MItDag dagIterator(MItDag::kBreadthFirst, MFn::kInvalid, &result);
	MayaStatusCheck(result);
	MDagPath dagPath;
	for( ; !dagIterator.isDone(); dagIterator.next()){
		result = dagIterator.getPath(dagPath);
		MayaStatusCheck(result);
		MFnDagNode dagNode(dagPath, &result);
		MayaStatusCheck(result);
		// 有効なDagノードかチェック
		if(!checkValidDagNode(dagPath)){ continue; }
		// インスタンス化されていればキャンセル
		u_int instanceNumber = dagPath.instanceNumber(&result);
		MayaStatusCheck(result);
		if(instanceNumber > 0){ continue; }
		// トランスフォームファンクションを持っていなければキャンセル
		// これでworldオブジェクトをはじける
		if(!dagPath.hasFn(MFn::kTransform)){ continue; }
		// 名前の取得
		MString dagName = dagNode.name(&result);
		MayaStatusCheck(result);
		// グラウンドプレーンならキャンセル
		if(dagName == "groundPlane_transform"){ continue; }
		// シーンノードの解析
		if(!analysisSceneNode(dagPath)){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// 有効Dagノードチェック
bool TranslationSceneNodeManager::checkValidDagNode(const MDagPath& dagPath){
	// DAGノードのフィルタリング
	// もっとスマートにしたい
	MStatus result;
	MFnDagNode dagNode(dagPath, &result);
	MayaStatusCheck(result);
	// 中間オブジェクトならキャンセル
	if(dagNode.isIntermediateObject()){ return false; }
	// カメラならキャンセル
	if(dagPath.hasFn(MFn::kCamera)){ return false; }
	// ロケータならキャンセル
	if(dagPath.hasFn(MFn::kLocator)){ return false; }
	// ルックアットならキャンセル
	if(dagPath.hasFn(MFn::kLookAt)){ return false; }
	// ジョイントならキャンセル
	if(dagPath.hasFn(MFn::kJoint)){ return false; }
	// IKエフェクタならキャンセル
	if(dagPath.hasFn(MFn::kIkEffector)){ return false; }
	// IKハンドルならキャンセル
	if(dagPath.hasFn(MFn::kIkHandle)){ return false; }
	// NURBSファンクションを持っていればキャンセル
	if(dagPath.hasFn(MFn::kNurbsSurface)){ return false; }
	// NURBSカーブファンクションを持っていればキャンセル
	if(dagPath.hasFn(MFn::kNurbsCurve)){ return false; }
	// Subdivファンクションを持っていればキャンセル
	if(dagPath.hasFn(MFn::kSubdiv)){ return false; }
	// Particleファンクションを持っていればキャンセル
	if(dagPath.hasFn(MFn::kParticle)){ return false; }
	// ラティスならキャンセル
	if(dagPath.hasFn(MFn::kLattice)){ return false; }
	// フルイドならキャンセル
	if(dagPath.hasFn(MFn::kFluid)){ return false; }
	// フィールドならキャンセル
	if(dagPath.hasFn(MFn::kField)){ return false; }
	return true;
}
//------------------------------------------------------------------------------
// シーンノードの解析
bool TranslationSceneNodeManager::analysisSceneNode(MDagPath dagPath){
	MStatus result;
	MFnDagNode dagNode(dagPath, &result);
	MayaStatusCheck(result);
	// 名前の重複が無いかチェック
	String sceneNodeName = dagNode.name(&result).asChar();
	MayaStatusCheck(result);
	TranslationSceneNode* exist = database_.get(sceneNodeName);
	if(exist != NULL){
		MayaErrorOut(String("TranslationSceneNodeManager::analysisSceneNode() "
			"名前が重複しています ") + sceneNodeName);
		return false;
	}
	TranslationSceneNode* sceneNode =
		new TranslationSceneNode(dagPath, sceneNodeName);
	if(!sceneNode->analyze()){
		delete sceneNode;
		return false;
	}
	database_.put(sceneNodeName, sceneNode);
	array_.add(sceneNode);
	return true;
}
//------------------------------------------------------------------------------
// ピボットのコンパイル
bool TranslationSceneNodeManager::compilePivot(
	TranslationModelManager* modelManager){
	// ピボットのコンパイル
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->compilePivot(this, modelManager)){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// アニメーションの収集
bool TranslationSceneNodeManager::collectAnimations(){
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->analyzeAnimation()){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// Lampへの変換
bool TranslationSceneNodeManager::convertToLamp(Scene* scene) const{
	// シーンノードのコンバート
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->convertToLamp(scene)){ return false; }
	}
	// リンクの接続
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->linkConnect(scene)){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// アニメーションの変換
bool TranslationSceneNodeManager::convertAnimation(
	AnimationManager* animationManager, AnimationSet* animationSet){
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->convertAnimation(animationManager, animationSet)){
			return false;
		}
	}
	return true;
}
//------------------------------------------------------------------------------
// クリア
int TranslationSceneNodeManager::clear(){
	int result = getCount();
	// 要素の削除
	for(int i = 0; i < result; i++){ delete array_.get(i); }
	array_.clear();
	database_.clear();
	return result;
}
//------------------------------------------------------------------------------
} // End of namespace LampForMaya
//------------------------------------------------------------------------------
